'
' ----------------------------------------------------------------------
' CALLING API FROM FB               June 17th, 2006          by  Jacques
' Note:
' ptr to data (= &H24 and &H2B here) is 'hand' extracted from
' CommonDatas.Lst file (set Menu/option NASM OUTPUT LIST ASSEMBLER CODE 
' FILE for NASM created it). FB_Int_1 and FB_Int_2 will be set to their
' value by RapidQ code using RapidQ function memcopy.
' ----------------------------------------------------------------------
'
OPTION EXPLICIT
OPTION BYVAL
'
Function CommonDatas (a,b,c,d) As Long
    Dim FB_Int_1, FB_Int_2 As Integer
    asm
        mov dword [FB_Int_1], 12345678          ' ptrFunc + &H24 
        mov dword [FB_Int_2], 12345678          ' ptrFunc + &H2B
    end asm
    Function = FB_Int_1 - FB_Int_2
End Function
'
' ----------------------------------------------------------------------
' All the problem consist in finding the   &H24, &H2B
' it's very easy:
' - Check the Menu/Options/NASM OUTPUT LIST ASSEMBLER CODE FILE
' - compile this file with FB to RQ INC
' - double clic on file CommonDatas.Lst, here it is:
'     1                                  ; ---- Start Nasm Function : COMMONDATAS -------------------
'     2                                  ; 06-17-2006 by FBtoRQINC extracted from:  FB_CommonDatas.Bas
'     3                                  ; Argument Number: 4
'     4                                  ; Compile me : Nasmw.exe COMMONDATAS.Nasm -fbin -o COMMONDATAS.Bin
'     5                                  ; ----------------------------------------------------------
'     6                                      bits 32
'     7                                      segment .text
'     8                                      COMMONDATAS
'     9                                  ; -------------
'    10 00000000 55                      push ebp
'    11 00000001 89E5                    mov ebp, esp
'    12 00000003 81EC0C000000            sub esp, 12
'    13 00000009 53                      push ebx
'    14 0000000A 56                      push esi
'    15 0000000B 57                      push edi
'    16 0000000C C745F400000000          mov dword [ebp-12], 0
'    17 00000013 C745F800000000          mov dword [ebp-8], 0
'    18 0000001A C745FC00000000          mov dword [ebp-4], 0
'    19                                  .Lt_0004:
'    20 00000021 C745F84E61BC00          mov dword [ebp-8], 12345678          
'    21 00000028 C745F44E61BC00          mov dword [ebp-12], 12345678          
'    22 0000002F 8B45F4                  mov eax, dword [ebp-12]
'    23 00000032 0345F8                  add eax, dword [ebp-8]
'    24 00000035 8945FC                  mov dword [ebp-4], eax
'    25                                  .Lt_0003:
'    26 00000038 8B45FC                  mov eax, dword [ebp-4]
'    27 0000003B 5F                      pop edi
'    28 0000003C 5E                      pop esi
'    29 0000003D 5B                      pop ebx
'    30 0000003E 89EC                    mov esp, ebp
'    31 00000040 5D                      pop ebp
'    32 00000041 C21000                  ret 16
'    33                                  ; ---- End Nasm Function COMMONDATAS -----------------------
'
'  we are interested by these two lines:
'    20 00000021 C745F84E61BC00          mov dword [ebp-8], 12345678          
'    21 00000028 C745F44E61BC00          mov dword [ebp-12], 12345678          
'  we will first discuss the first line:
'    20 00000021 C745F84E61BC00          mov dword [ebp-8], 12345678          
'       this is line 20, the code of this line begins at hexadecimal address
'       &h21, the resulting code for this line is C7 45 F8 4E 61 BC 00 (7 bytes
'       one after another in memory), mov dword [ebp-8], 12345678 is the 
'       NASM mnemonic for FB_INT_1 = 12345678. In Hexadecimal, 12345678 = 00 BC 61 .4E
'       what is written reverse in C7 45 F8 4E 61 BC 00. So these four bytes
'       are FB_INT_1 initialised. Now we need to know the address of it
'       C7   is at address   &H21
'       45   is at address   &H22
'       F8   is at address   &H23
'       4E   is at address   &H24     4E is the first bytes of FB_INT_1 and
'               &H24 = decimal 36  is the 'offset' of that first FB_INT_1 byte
'               from the start of the function CommonDatas known in RapidQ
'               as ptrCommonDatas. So in RapidQ, ptrCommonDatas + &H24 will
'               point to FB_Int_1 in in Function ComonDatas.
'               memcopy (ptrCommonDatas + &H24, VarPtr(RQ_Int_1), 4) will thus
'               initialise FB_Int_1 with RQ_Int_1     QED :)
'  for the second line, it's exactly the same ... except that we have to 
'  count in hexadecimal over 9 :)
'    21 00000028 C745F44E61BC00          mov dword [ebp-12], 12345678          
'       C7   is at address   &H28
'       45   is at address   &H29
'       F8   is at address   &H2A      ' hexa count: 0,1,2...,8,9,A,B,C,D,E,10,11, ...
'       4E   is at address   &H2B      4E is the first bytes of FB_INT_2 and
'               &H2B = decimal 43  is the 'offset' of that first FB_INT_2 byte
'               from the start of the function CommonDatas known in RapidQ
'               as ptrCommonDatas.  
'               memcopy (ptrCommonDatas + &H2B, VarPtr(RQ_Int_2), 4) will thus
'               initialise FB_Int_2 with RQ_Int_2     QED :)
'
' -------------------------------------------------------------------------------
' If you like headakes or as exercise, you will see that FB initialises FB_Int_1
' and FB_Int_2 in lines 16 and 17 '    16 0000000C C745F400000000          mov dword [ebp-12], 0
'    17 00000013 C745F800000000          mov dword [ebp-8], 0
' and that our FB inline asm code is useless
'
' Function CommonDatas (a,b,c,d) As Long
'    Dim FB_Int_1, FB_Int_2 As Integer
'    Function = FB_Int_1 + FB_Int_2
' End Function
'
' that NASM will compile and .Lst:
'    10 00000000 55                      push ebp
'    11 00000001 89E5                    mov ebp, esp
'    12 00000003 81EC0C000000            sub esp, 12
'    13 00000009 C745F400000000          mov dword [ebp-12], 0     ' FB_Int_2  at  &H0C
'    14 00000010 C745F800000000          mov dword [ebp-8], 0      ' FB_Int_1  at  &H13
'    15 00000017 C745FC00000000          mov dword [ebp-4], 0
'    16                                  .Lt_0004:
'    17 0000001E 8B45F4                  mov eax, dword [ebp-12]
'    18 00000021 0345F8                  add eax, dword [ebp-8]
'    19 00000024 8945FC                  mov dword [ebp-4], eax
'    20                                  .Lt_0003:
'    21 00000027 8B45FC                  mov eax, dword [ebp-4]
'    22 0000002A 89EC                    mov esp, ebp
'    23 0000002C 5D                      pop ebp
'    24 0000002D C21000                  ret 16
'
'  in RQ:  memcopy (ptrCommonDatas + &H13, VarPtr(RQ_Int_1), 4)  set FB_Int_1 = RQ_Int_1
'          memcopy (ptrCommonDatas + &H0C, VarPtr(RQ_Int_2), 4)  set FB_Int_2 = RQ_Int_2
'  The first dim in FB has the lower [ebp-xx]
'    (see eaxample FB_CommonDatas_2.Bas and RQ_CommonDatas_2.Bas)
' ---------------------------------------------------------------------------------
'
